﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace SWPP

{
    public class CreateForceWraith : PowerBase
    {
        public override void Start()
        {
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Hand";

            //Always keep this
            DisablesGrips = false;
            base.Start();
        }
        
        //This is the actual power part of your power, this function will trigger when the activation limb is used.
        public override void UsePower()
        {
            //This if statement exists to check if your power is selected and enabled in the power menu
            if (Enabled)
            {
                                        GameObject wraith;
        wraith = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzwraith").Prefab, this.transform.position, Quaternion.Euler(0, 0, 0));
        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzwraith"), wraith);
        this.transform.parent = this.transform.parent;
        this.transform.parent = this.transform;
        wraith.transform.position = wraith.transform.position;
        wraith.transform.parent = wraith.transform;
            }
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body,Sprite powerIcon = null,string powerName = "Create Force Wraith")
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<CreateForceWraith>() || body.GetComponent<CreateForceWraith>().PowerName != powerName)
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                var Power = body.gameObject.AddComponent<CreateForceWraith>();
                
                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                if(powerIcon == null)
                {
                    Power.PowerIcon = SWPP.IconCreateForceWraith;
                }
                else
                {
                    Power.PowerIcon = powerIcon;
                }

                Power.PowerName = powerName;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    Power.UsePower();
                };
            }
        }
    }
}

