﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace SWPP
{
    public class Doppelganger : PowerBase
    {
        private LimbBehaviour Head;

        public override void Start()
        {
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Hand";

            //Always keep this
            DisablesGrips = false;
            base.Start();
        }
        
        //This is the actual power part of your power, this function will trigger when the activation limb is used.
        public override void UsePower()
        {
            //This if statement exists to check if your power is selected and enabled in the power menu
            if (Enabled)
            {
var clone = GameObject.Instantiate<GameObject>(ModAPI.FindSpawnable(gameObject.GetComponent<LimbBehaviour>().Person.gameObject.name).Prefab);
                clone.AddComponent<DeregisterBehaviour>();
                clone.GetComponent<PersonBehaviour>().RandomisedSize = false;
                clone.transform.localScale = gameObject.GetComponent<LimbBehaviour>().Person.transform.localScale;
                clone.transform.position = gameObject.GetComponent<LimbBehaviour>().Person.Limbs[2].transform.position + new Vector3(1.5f, 0f, 0f);
                CatalogBehaviour.PerformMod(ModAPI.FindSpawnable(gameObject.GetComponent<LimbBehaviour>().Person.name), clone);
                UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(clone, "Doppelgänger"));
                clone.gameObject.name = gameObject.GetComponent<LimbBehaviour>().Person.gameObject.name;
                clone.AddComponent<AudioSourceTimeScaleBehaviour>();
                clone.AddComponent<SerialiseInstructions>().OriginalSpawnableAsset = ModAPI.FindSpawnable(gameObject.GetComponent<LimbBehaviour>().Person.gameObject.name);
                clone.gameObject.GetComponent<PersonBehaviour>().SetBodyTextures(gameObject.GetComponent<SkinMaterialHandler>().renderer.sprite.texture, null, null);
                foreach (var limb in clone.GetComponent<PersonBehaviour>().Limbs)
                {
                    limb.gameObject.AddComponent<YOUWILLDIEWITHIN30SECONDSHAHAHAHAHA>();
                }
            }
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person,Sprite powerIcon = null,string powerName = "Doppelgänger")
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<Doppelganger>() || body.GetComponent<Doppelganger>().PowerName != powerName)
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                var Power = body.gameObject.AddComponent<Doppelganger>();
                
                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                if(powerIcon == null)
                {
                    Power.PowerIcon = SWPP.IconDoppleganger;
                }
                else
                {
                    Power.PowerIcon = powerIcon;
                }

                Power.PowerName = powerName;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    Power.UsePower();
                };
            }
        }
    }
    public class YOUWILLDIEWITHIN30SECONDSHAHAHAHAHA : MonoBehaviour
    {

                private void Start()
        {
 StartCoroutine(poop());
        }
 public IEnumerator poop()
 {
     ModAPI.CreateParticleEffect("Flash", this.transform.position);
yield return new WaitForSeconds(30f);
this.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
ModAPI.CreateParticleEffect("Flash", this.transform.position);
 }
    }
}