﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace SWPP
{
    public class Ionize : PowerBase, Messages.IUseContinuous //lazy
    {
        private int time = 0;
        private int Playing = 0;

        public override void Start()
        {
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Hand";

            //Always keep this
            DisablesGrips = false;
            base.Start();
        }

        //This is the actual power part of your power, this function will trigger when the activation limb is used.
        public override void UsePower()
        {
        }

        public void UseContinuous(ActivationPropagation prop)
        {
            if (Enabled)
            {
                this.time += 1;
                this.Playing = 2;
                if ((this.time % 15) == 0)
                {
                     this.gameObject.layer = LayerMask.NameToLayer("CollidingDebris");
                    SimpleLightingEmitterBehaviour.Instance.Emit(this.transform.TransformPoint(0f, -0.15f, 0f), -this.transform.up, 20f, 0.10f, OnHit, new Color(0.3f, 0f, 1f, 0.8f), LayerMask.GetMask(new string[] { "Objects", "Bounds" }), 0, 156, 0.07f, 0.002f);
                    this.gameObject.layer = LayerMask.NameToLayer("Objects");
                }
            }
        }

        public void OnHit(PhysicalBehaviour phys, Vector2 pos)
        {
                LimbBehaviour limb;
                if (phys.gameObject.TryGetComponent<LimbBehaviour>(out limb) && this.gameObject.GetComponent<LimbBehaviour>().Person.Limbs.Contains<LimbBehaviour>(limb))
                {
                    return;
                }
phys.gameObject.transform.SendMessage("OnEMPHit", SendMessageOptions.DontRequireReceiver);
phys.gameObject.transform.SendMessage("Break", SendMessageOptions.DontRequireReceiver);
            ModAPI.CreateParticleEffect("Spark", pos);
            ModAPI.CreateParticleEffect("BigZap", pos);
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, Sprite powerIcon = null, string powerName = "Ionize")
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<Ionize>() || body.GetComponent<Ionize>().PowerName != powerName)
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                var Power = body.gameObject.AddComponent<Ionize>();

                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                if (powerIcon == null)
                {
                    Power.PowerIcon = SWPP.IconIonize;
                }
                else
                {
                    Power.PowerIcon = powerIcon;
                }

                Power.PowerName = powerName;
            }
        }
    }
}
