﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace SWPP
{
    //An empty class for you to copy paste and fill with your own powers!
    public class MagicPush : PowerBase
    {
        AudioSource auds;

        //Changes how hard people get swooshied
        public float ForceAmount = 40;

        public void Start()
        {
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Hand";

            //Always keep this
            DisablesGrips = false;
            base.Start();
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }
        
        //This is the actual power part of your power, this function will trigger when the activation limb is used.
        public override void UsePower()
        {
            //This if statement exists to check if your power is selected and enabled in the power menu
            if (Enabled)
            {
                RaycastHit2D hit2D = Physics2D.Raycast(transform.position, -transform.up, 5 * 1.6f);

                if (hit2D)
                {
                    if (hit2D.transform.gameObject.GetComponent<LimbBehaviour>() && !GetComponent<LimbBehaviour>().Person.Limbs.Contains(hit2D.transform.gameObject.GetComponent<LimbBehaviour>()))

                    {
                        foreach (var item in hit2D.transform.gameObject.GetComponent<LimbBehaviour>().Person.GetComponentsInChildren<PhysicalBehaviour>())
                        {
                            item.GetComponent<Rigidbody2D>().AddForce(-transform.up * ForceAmount);
                            ModAPI.CreateParticleEffect("Vapor", hit2D.transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs[2].transform.position).transform.localScale *= 5;
                         //   auds.PlayOneShot(ResourceStorage.Sound_MagicPushSound);
                        }
                    }
                }

            }
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person,Sprite powerIcon = null,string powerName = "Force Push",float forceAmount = 60)
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<MagicPush>() || body.GetComponent<MagicPush>().PowerName != powerName)
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                var Power = body.gameObject.AddComponent<MagicPush>();
                
                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                if(powerIcon == null)
                {
                    Power.PowerIcon = SWPP.IconForcePush;
                }
                else
                {
                    Power.PowerIcon = powerIcon;
                }

                Power.PowerName = powerName;

                Power.ForceAmount = forceAmount;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    Power.UsePower();
                };
            }
        }
    }
}
