using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;

namespace SWPP
{
    #region SyringeObjects
    internal class HealSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(HealPoison);
        }
    }
        internal class IonizeSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(IonizePoison);
        }
    }
            internal class MindTrickSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(MindTrickPoison);
        }
    }
                internal class ForcePullSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForcePullPoison);
        }
    }
                    internal class ForceFreezeSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceFreezePoison);
        }
    }
                        internal class ForceLightningSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceLightningPoison);
        }
    }
                            internal class ForceBleedingSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceBleedingPoison);
        }
    }
                                internal class ForceDrainSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceDrainPoison);
        }
    }
                                    internal class ForceChokeSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceChokePoison);
        }
    }
                                    internal class ForceWraithSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceWraithPoison);
        }
    }
                                        internal class ForceBarrierSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceBarrierPoison);
        }
    }
                                        internal class DarkTransferSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(DarkTransferPoison);
        }
    }
                                        internal class ForceStunSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceStunPoison);
        }
    }
                                        internal class ElectricJudgementSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ElectricJudgementPoison);
        }
    }
                                        internal class ForceCombustionSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ForceCombustionPoison);
        }
    }
                                        internal class DarkshearSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(DarkshearPoison);
        }
    }
                                         internal class DoppelgangerSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(DoppelgangerPoison);
        }
    }
    
    
    
    

    #endregion

    public class HealPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceHeal>())
                {
                    ForceHeal.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>());
                }
            }
                    
        }

    }
        public class IonizePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<Ionize>())
                {
                    Ionize.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>());
                }
            }
                    
        }

    }
            public class MindTrickPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<MindTrick>())
                {
                    MindTrick.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }

    }
                public class ForcePullPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<MagicPush>())
                {
                    MagicPush.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person, null, "Force Pull", -40);
                    MagicPush.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }

    }
                    public class ForceFreezePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceFreeze>())
                {
                    ForceFreeze.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }

    }
                        public class ForceLightningPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceLightning>())
                {
                    ForceLightning.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>());
                }
            }
                    
        }

    }
                public class ForceBleedingPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceBleeding>())
                {
                    ForceBleeding.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }

    }
                    public class ForceDrainPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceDrain>())
                {
                    ForceDrain.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }

    }
                        public class ForceChokePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceChoke>())
                {
                    ForceChoke.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }
    }
        public class ForceWraithPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
                        if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<CreateForceWraith>())
                {
                    CreateForceWraith.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>());
                }
            }
                    
        }
    }
                            public class ForceBarrierPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceBarrier>())
                {
                    ForceBarrier.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                    physicalBehaviour.GetComponent<ForceBarrier>().ShieldSprite = GameObject.FindObjectOfType<ForceBarrierSyringe>().GetComponent<ResourceStorage>().sprites[0];
                }
            }
                    
        }
    }
                                public class DarkTransferPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<DarkTransfer>())
                {
                    DarkTransfer.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }
    }
                             public class ForceStunPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceStun>())
                {
                    ForceStun.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }
    }
                        public class ElectricJudgementPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ElectricJudgement>())
                {
                    ElectricJudgement.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>());
                }
            }
                    
        }

    }
                                public class ForceCombustionPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<ForceCombustion>())
                {
                    ForceCombustion.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
                    
        }
    }
                            public class DarkshearPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
            if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<Darkshear>())
                {
                    Darkshear.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                    physicalBehaviour.GetComponent<Darkshear>().ShieldSprite = GameObject.FindObjectOfType<DarkshearSyringe>().GetComponent<ResourceStorage>().sprites[0];
                }
            }
                    
        }
    }
                                public class DoppelgangerPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;
             if (physicalBehaviour.GetComponent<LimbBehaviour>().GetComponent<GripBehaviour>())
            {
                if (!physicalBehaviour.GetComponent<Doppelganger>())
                {
                    Doppelganger.SetUpPower(physicalBehaviour.GetComponent<LimbBehaviour>(), person);
                }
            }
        }
    }
}    