using System.Collections;
using System;
using UnityEngine;
using System.Linq;
using System.Collections.Generic;

namespace SWPP
{
    public class SWPP : MonoBehaviour
    {
        #region Sprites
        public static Sprite Bladey = ModAPI.LoadSprite("Lightsabers/Blade.png");
        #endregion

        #region grebvious
                public static GameObject boobies;
         #endregion

        #region PowerIcons
        public static Sprite IconForcePush = ModAPI.LoadSprite("Ui/Power Icons/Force Push.png");
        public static Sprite IconForceHeal = ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png");
        public static Sprite IconForcePull = ModAPI.LoadSprite("Ui/Power Icons/Force Pull.png");
        public static Sprite IconForceChoke = ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png");
        public static Sprite IconForceLightning = ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png");
        public static Sprite IconMindTrick = ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png");
        public static Sprite IconForceDrain = ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png");
        public static Sprite IconForceFreeze = ModAPI.LoadSprite("Ui/Power Icons/Force Freeze.png");
        public static Sprite IconForceBleeding = ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png");
        public static Sprite IconIonize = ModAPI.LoadSprite("Ui/Power Icons/Ionize.png");
        public static Sprite IconCreateForceWraith = ModAPI.LoadSprite("Ui/Power Icons/Create Force Wraith.png");
        public static Sprite IconForceBarrier = ModAPI.LoadSprite("Ui/Power Icons/Force Barrier.png");
        public static Sprite IconDarkTransfer = ModAPI.LoadSprite("Ui/Power Icons/Dark Transfer.png");
        public static Sprite IconElectricJudgement = ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png");
        public static Sprite IconForceCombustion = ModAPI.LoadSprite("Ui/Power Icons/Force Combustion.png");
        public static Sprite IconDarkshear = ModAPI.LoadSprite("Ui/Power Icons/Darkshear.png");
        public static Sprite IconForceStun = ModAPI.LoadSprite("Ui/Power Icons/Force Stun.png");
        public static Sprite IconDoppleganger = ModAPI.LoadSprite("Ui/Power Icons/Doppleganger.png");
        #endregion

        public static string ModTag = " [SWPP]"; //Whilst not required, modded items should contain 'tags' at the end of their names to prevent errors in which two mods have an item of the same name.







        public static void Main()
        {
            CategoryBuilder.Create("Star Wars Power Pack", "Contains many Star Wars characters and items. - Team Wilson", ModAPI.LoadSprite("logo_category.png"));


            #region syriunges

                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Heal", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to heal themselves by activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/LThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<HealSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(0, 15, 255, 255);
        }
    }
);
                    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Stun", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to stun people by pointing at them and activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/LThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForceStunSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(0, 15, 255, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Ionize", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to fire lightning form their hands that damages electronics", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/LThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<IonizeSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(0, 15, 255, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Mind Trick", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to knock people out by pointing at them and activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/LThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<MindTrickSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(0, 15, 255, 255);
        }
    }
);
                    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Electric Judgement", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to fire coloured lightning from their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/LThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ElectricJudgementSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(0, 15, 255, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Pull/Force Push", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the Force Pull and Force Push abilites", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/BThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForcePullSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(67, 67, 67, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Freeze", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to freeze anything by pointing at it and activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/BThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForceFreezeSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(67, 67, 67, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Lightning", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to shoot lightning out of their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/BThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForceLightningSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(67, 67, 67, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Bleeding", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to make anyone bleed where they point at by activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/DThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForceBleedingSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 15, 0, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Drain", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to take others life to heal themselves by pointing at someone and activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/DThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForceDrainSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 15, 0, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Choke", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to choke people by pointing at them and activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/DThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForceChokeSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 15, 0, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Create Force Wraith", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to create Force Wraiths by activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/DThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForceWraithSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 15, 0, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Barrier", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to create a barrier by activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/BThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ResourceStorage>();
            Instance.GetComponent<ResourceStorage>().sprites.Add(ModAPI.LoadSprite("Shield.png"));
            Instance.AddComponent<ForceBarrierSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(67, 67, 67, 255);
        }
    }
);
                        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Dark Transfer", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to heal others by pointing at them", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/BThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<DarkTransferSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(67, 67, 67, 255);
        }
    }
);
                    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Force Combustion", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to make anything explode by pointing at it", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/BThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ForceCombustionSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(67, 67, 67, 255);
        }
    }
);
                    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Darkshear", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to create a spear by activating their hands, activating the spear will remove it from their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/DThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<ResourceStorage>();
            Instance.GetComponent<ResourceStorage>().sprites.Add(ModAPI.LoadSprite("r.png"));
            Instance.AddComponent<DarkshearSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 15, 0, 255);
        }
    }
);
                ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //item to derive from
        NameOverride = ModTag + "<color=#04BED5>[Syringe]<color=white> Doppelgänger", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability to create a clone of themselves that will vanish within 15 seconds by activating their hands", //new item description
        CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Syringes/BThumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Component.Destroy(Instance.GetComponent<LifeSyringe>());
            Instance.AddComponent<DoppelgangerSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(67, 67, 67, 255);
        }
    }
);
#endregion

#region people

            ///HIGHLIGHT FROM HERE
            // Han Solo
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Han Solo", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I've got a bad feeling about this. - Han Solo", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Han Solo/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Han Solo/Han Solo.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Han Solo/Solo.png"), "Han Solos Solo Costume", "Han Solos Solo Costume");


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE

            ///HIGHLIGHT FROM HERE
            // Han Solo
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Imperial Royal Guard", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "... - Royal Guard", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Royal Guard/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Royal Guard/Royal Guard.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // The Mandalorian
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>The Mandalorian", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I can bring you in warm, or I can bring you in cold. - The Mandalorian", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/The Mandalorian/thumb2.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/The Mandalorian/The Mandalorian.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/The Mandalorian/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/The Mandalorian/cape01.png"));


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

                        // The Mandalorian
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Kyle Katarn", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Whenever I need to find you, you're always in some sort of trouble. - Kyle Katarn", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Kyle Katarn/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Kyle Katarn/Kyle Katarn.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                                                ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                         
                         
                     
                     
                        ElectricJudgement.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));

                        person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 1f;

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );

            ///TO HERE
                                    // The Mandalorian
            ///TO HERE
                        ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Grand Inquisitor", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "There are some things far more frightening than death. - Grand Inquisitor", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Grand Inquisitor/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Grand Inquisitor/Grand Inquisitor.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceChoke.SetUpPower(person.Limbs[11], person);
                        ForceChoke.SetUpPower(person.Limbs[13], person);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                                    ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Grand Moff Tarkin", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Evacuate? In our moment of triumph? I think you overestimate their chances! - Grand Moff Tarkin", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Grand Moff Tarkin/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Grand Moff Tarkin/Grand Moff Tarkin.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                    ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Agent Kallus", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "It could signify the spark of rebellion. Next time they make a move we'll be waiting for them to snuff out that spark before it catches fire. - Agent Kallus", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Agent Kallus/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Agent Kallus/Agent Kallus.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                                    ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Dengar", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Ha ha ha ha! I can't believe I'm getting paid for this! - Dengar", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Dengar/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Dengar/Dengar.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                                ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Sabine Wren", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "We're not exactly anything. We're a crew. A team. In some ways, a family. - Sabine Wren", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Sabine Wren/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Sabine Wren/Sabine Wren.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Sabine Wren/emo girl.png"), "Sabine Wren Helmetless", "Sabine Wren Helmetless");

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Kanan Jarrus", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I know nothing of a larger rebellion... and if I did, I'd rather give my life than tell you! - Kanan Jarrus", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Kanan Jarrus/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Kanan Jarrus/Kanan Jarrus.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Kanan Jarrus/Head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                         
                         
                                             
                     
                        MindTrick.SetUpPower(person.Limbs[11], person);
                        MindTrick.SetUpPower(person.Limbs[13], person);
                        ElectricJudgement.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                        ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Jedi Billson", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Not as bright as the lightside - Jedi Billson", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Jedi Billson/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Jedi Billson/Jedi Billson.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        foreach (var item in person.Limbs)
                {
          item.transform.root.localScale *= 0.98f;
                }

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                        ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Sith Wilson", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I love pants and I love feet - Sith Wilson", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Sith Wilson/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Sith Wilson/Sith Wilson.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Sith Wilson/sith wilson cape.png"), 0.08f, ModAPI.LoadSprite("Characters/Sith Wilson/sith wilson cape2.png"));

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE
                        ///TO HERE
                        ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Fennec Shand", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Take some advice, kid. You wanna be a bounty hunter? Make the best deal for yourself and survive. - Fennec Shand", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Fennec Shand/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Fennec Shand/Fennec SHand.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Ezra Bridger", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The Force isn't a weapon! But you'll never understand that. - Ezra Bridger", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Erza Bridger/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Erza Bridger/Erza Bridger.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                         
                         
                                             
                     
                        ElectricJudgement.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Erza Bridger/hair.png"),"Padawan Ezra Bridger", "Padawan Ezra Bridger");

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE
                        // Dark Trooper
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>IG-88", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Unlike those that breathe, I am but a machine. And for one such as I, time means nothing. - IG-88", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/IG-88/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/IG-88/IG-88.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE
                                    // Dark Trooper
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>IG-11", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "There is nothing to be sad about. I have never been alive. - IG-11", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/IG-11/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/IG-11/IG-11.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Darth Revan
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Darth Revan", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I am Revan reborn. And before me you are nothing. - Darth Revan", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Darth Revan/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Darth Revan/Darth Revan.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Darth Revan/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/Darth Revan/cape01.png"));

                        ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        ForceLightning.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceLightning.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceBleeding.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                        ForceBleeding.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                                                MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));

person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 1f;

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Darth Revan
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Darth Nihilus", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = " ... - Darth Nihilus", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Darth Nihilus/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Darth Nihilus/Darth Nihilus.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Darth Nihilus/nihilus cape1.png"), 0.08f, ModAPI.LoadSprite("Characters/Darth Nihilus/nihilus cape2.png"));


                        ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceDrain.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceDrain.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceLightning.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceLightning.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceBleeding.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                        ForceBleeding.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                                                                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                        ElectricJudgement.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ForceStun.SetUpPower(person.Limbs[11], person);
                        ForceStun.SetUpPower(person.Limbs[13], person);
                        DarkTransfer.SetUpPower(person.Limbs[11], person);
                        DarkTransfer.SetUpPower(person.Limbs[13], person);
                         
                         
                                             
                     
                        CreateForceWraith.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Create Force Wraith.png"));
                        CreateForceWraith.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Create Force Wraith.png"));

person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 1f;

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Darth Vader
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Darth Vader", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Be careful not to choke on your aspirations. - Darth Vader", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Darth Vader/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Darth Vader/Darth Vader.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Darth Vader/Head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Darth Vader/cape01.png"), 0.08f, ModAPI.LoadSprite("Characters/Darth Vader/cape02.png"));

                        ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceBleeding.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                        ForceBleeding.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                                                                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                         
                         
                                             
                     

person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 1f;

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );


            ///HIGHLIGHT FROM HERE
            // Kylo Rennnnenenenenennnnennnennenen
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>Kylo Ren", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The Resistance is dead, the war is over, and when I kill you, I will have killed the last Jedi! - Kylo Ren", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Kylo Ren/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Kylo Ren/Kylo Ren.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                                                ForceFreeze.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Freeze.png"));
                        ForceFreeze.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Freeze.png"));
                        ForceLightning.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceLightning.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                                                                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);

person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 1f;

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

            // Darth Revan
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Darth Maul", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "KENOBIIIII! - Darth Maul", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Darth Maul/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //no balls?

                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Darth Maul/Darth Maul.png"); // copy and paste me into setbodytextures with a different location (person.SetBodyTextures(skin, INSERT HERE FLESH, INSERT BONE HERE))

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin, ModAPI.LoadTexture("Characters/Darth Maul/flesh.png"), ModAPI.LoadTexture("Characters/Darth Maul/bone.png"));

                        ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceBleeding.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                        ForceBleeding.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                                                                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                        ForceFreeze.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Freeze.png"));
                        ForceFreeze.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Freeze.png"));
                         
                         
                                             
                     
                        ElectricJudgement.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));


                        foreach (var body in person.Limbs)
                        {
                            if (body.RoughClassification == LimbBehaviour.BodyPart.Legs)
                            {
                                body.IsAndroid = true;
                                body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
                            }
                        }

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );

            ///HIGHLIGHT FROM HERE
            // Rey (Scavenger)
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>Rey", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Are you offering me a job? - Rey", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Rey (Scavanger)/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Rey (Scavanger).png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin, null, null, 1);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Rey (Scavanger)/Head.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Bastila Shan (Fallen)
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Bastila Shan (Fallen)", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "You are a weak and pathetic servant of the light! - Bastila Shan (Fallen)", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Bastila Shan (Fallen)/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Bastila Shan (Fallen)/Bastila Shan (Fallen).png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin, null, null, 1);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Bastila Shan (Fallen)/Head.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Bastila Shan (Fallen)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Bastila Shan (Fallen)/Head Bone.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                                                ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceBleeding.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                        ForceBleeding.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                                                ForceDrain.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceDrain.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                                                MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                                                ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));

                                                                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Darth Malak
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Darth Malak", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Savior, conqueror, hero, villain. You are all things, Revan... and yet you are nothing. - Darth Malak", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Darth Malak/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Darth Malak/Darth Malak.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Darth Malak/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/Darth Malak/cape01.png"));
                        ForceDrain.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceDrain.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceBleeding.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                        ForceBleeding.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                                                                                                MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceLightning.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceLightning.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));

                        person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 1f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 0f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 0f;



                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Boba Fett, Scion of Jango
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Boba Fett, Scion of Jango", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I'm a simple man making his way through the galaxy. Like my father before me. - Boba Fett, Scion of Jango", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Boba Fett, Scion of Jango/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Boba Fett, Scion of Jango/Boba Fett, Scion of Jango.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin, null, null, 1);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Boba Fett, Scion of Jango/Head.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Boba Fett, Scion of Jango/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Boba Fett, Scion of Jango/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();


                        person.Limbs[1].gameObject.AddComponent<JetPack>();

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Sith Empire Trooper
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Sith Empire Trooper", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Something evil, probably. - Sith Empire Trooper", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Sith Empire Trooper/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Sith Empire Trooper/Sith Empire Trooper.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin, null, null, 1);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Count Dooku
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Count Dooku", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I've been looking forward to this. - Count Dooku", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Count Dooku/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Count Dooku/Count Dooku.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Count Dooku/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/Count Dooku/cape01.png"));
                        ForceLightning.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceLightning.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                                                                                                                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                         
                         
                                             
                     
                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));

person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 1f;


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE
                        ///HIGHLIGHT FROM HERE
            // Count Dooku
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Asajj Ventress", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I'm not much of a talker. - Asajj Ventress", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Asajj Ventress/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Asajj Ventress/Asajj Ventress.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                        ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE


            // Moff Gideon
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Moff Gideon", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Activate the Dark Troopers. - Moff Gideon", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Moff Gideon/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Moff Gideon/Moff Gideon.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Moff Gideon/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/Moff Gideon/cape01.png"));


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                        // Moff Gideon
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Greef Karga", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The Empire is gone, Mando. All that are left are mercenaries and warlords. - Greef Karga", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Greef Karga/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Greef Karga/Greef Karga.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                                    // Moff Gideon
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Bossk", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I'll be a brother to you, all right. And I know how, believe me. - Bossk", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Bossk/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Bossk/Bossk.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                        ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Greedo", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "It's too late. You should have paid him when you had the chance. Jabba's put a price on your head so large, every bounty hunter in the galaxy will be looking for you. I'm lucky I found you first. - Greedo", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Greedo/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Greedo/Greedo.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Greedo/head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                                    // Moff Gideon
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Bo-Katan Kryze", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "It cannot cut through pure beskar. I will kill the Moff and retake what is rightfully mine. - Bo-Katan Kryze", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Bo-Katan Kryze/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Bo-Katan Kryze/Bo-Katan Kryze.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Dark Trooper
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Dark Trooper", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Something mean, maybe. - Dark Trooper", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Dark Trooper/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Dark Trooper/Dark Trooper.png");
                        var flesh = ModAPI.LoadTexture("Characters/Dark Trooper/flesh layer.png");
                        var bone = ModAPI.LoadTexture("Characters/Dark Trooper/bone layer.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Dark Trooper/Head.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Dark Trooper/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Dark Trooper/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Dark Trooper
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Storm Trooper", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Rebels! - Storm Trooper", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Storm Trooper/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Storm Trooper/Storm Trooper.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Storm Trooper/Head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

            ///HIGHLIGHT FROM HERE

            ///HIGHLIGHT FROM HERE
            // sdf
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Clone Trooper", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "We’re just clones, sir. We’re meant to be expendable. - Clone Trooper", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Clone Trooper/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Clone Trooper/Clone Trooper.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Clone Trooper/Head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

            ///HIGHLIGHT FROM HERE
            // Dark Trooper
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>B1-Series Battle Droid", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Roger Roger. - B1-Series Battle Droid", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/B1/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/B1/B1.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);



                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

            ///HIGHLIGHT FROM HERE
            // Dark Trooper
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>First Order Storm Trooper", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I will tighten these restraints, scavenger scum. - First Order Storm Trooper", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Storm Trooper/firstorderthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Storm Trooper/First Order.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Storm Trooper/FHead.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

            ///HIGHLIGHT FROM HERE
            // Dark Trooper
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>Sith Trooper", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Death to the Resistance. - Sith Trooper", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Sith Trooper/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Sith Trooper/Sith Trooper.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Sith Trooper/Head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Obi-Wan Kenobi
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Obi-Wan Kenobi", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Hello there! - Obi-Wan Kenobi", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Obi-Wan Kenobi/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Obi-Wan Kenobi/Obi-Wan Kenobi.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Obi-Wan Kenobi/Obi Wan Episode 1.png"), "Obi-Wan Kenobi (episode 1)", "Obi-Wan Kenobi (episode 1)");

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Obi-Wan Kenobi/Obi Wan Episode 2.png"), "Obi-Wan Kenobi (episode 2)", "Obi-Wan Kenobi (episode 2)");


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///HIGHLIGHT FROM HERE
            // Obi-Wan Kenobi
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Ahsoka Tano", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I like firsts. Good or bad they're always memorable. - Ahsoka Tano", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Ahsoka Tano/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Ahsoka Tano/Ahsoka Tano.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Ahsoka Tano/Head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");



                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();


                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
                               ///HIGHLIGHT FROM HERE
            // Obi-Wan Kenobi
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Padmé Amidala", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "So this is how liberty dies. - Padmé Amidala", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Padame/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Padame/Padame.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Padame/Head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");



                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();





                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///HIGHLIGHT FROM HERE
            // dfgdfgdfg
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Yoda", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Patience you must have my young Padawan. - Yoda", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Yoda/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Yoda/Yoda.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        foreach (var body in person.Limbs)
                        {
                 body.transform.root.localScale *= 0.98f;
                        }


                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                         
                         
                                             
                     
                        ForceStun.SetUpPower(person.Limbs[11], person);
                        ForceStun.SetUpPower(person.Limbs[13], person);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            //Old Ben Kenobi
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Old Ben Kenobi", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "You can't win, Darth. If you strike me down I will become more powerful than you could possibly imagine! - Old Ben Kenobi", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Obi-Wan Kenobi/thumb2.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Obi-Wan Kenobi/Old Ben.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                         
                         
                                             
                     


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            // Luke Skywalker
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Luke Skywalker", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I'll never turn to the dark side. You've failed your Highness. I'm a Jedi, like my father before me. - Luke Skywalker", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Luke Skywalker/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Luke Skywalker/Luke Skywalker.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Luke Skywalker/Luke Skywalker Jedi Knight.png"), "Jedi Knight Luke Skywalker", "Jedi Knight Luke Skywalker");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Luke Skywalker/Commander Luke Skywalker.png"),"Commander Luke Skywalker", "Commander Luke Skywalker");


                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                         
                         
                                             
                     



                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered


                    }
                }
                   );
                               // Luke Skywalker
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Rebel Soldier", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Something good maybe - Rebel Soldier", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Rebel Trooper/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Rebel Trooper/Rebel Trooper.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered


                    }
                }
                   );
                               ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Lando Calrissian", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "How you doin', ya old pirate? - Lando Calrissian", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Lando Calrissian/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Lando Calrissian/Lando Calrissian.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam

                                                PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Lando Calrissian/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/Lando Calrissian/cape01.png"));
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered


                    }
                }
                   );
                               // old luke
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>Old Luke", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I won't fail you. I'm not afraid.- Old Luke", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Old Luke/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Old Luke/Old Luke.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                                        ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceStun.SetUpPower(person.Limbs[11], person);
                        ForceStun.SetUpPower(person.Limbs[13], person);

                                    foreach (var body in person.Limbs)
            {

                if (body.gameObject.name == "UpperArmFront")
                {
                                        body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                    OtherStuff.SetBodyPartTexture(body, ModAPI.LoadTexture("Characters/Old Luke/robo.png"), ModAPI.LoadTexture("Characters/Old Luke/robo.png"));
                }
                else if (body.gameObject.name == "LowerArmFront")
                {
                                        body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                    OtherStuff.SetBodyPartTexture(body, ModAPI.LoadTexture("Characters/Old Luke/robo.png"), ModAPI.LoadTexture("Characters/Old Luke/robo.png"));
                }
            }


person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 1f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 0f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 0f;



                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered


                    }
                }
                   );
            //Mace Windu
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequels]<color=white>Mace Windu", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "You are on this council, but we do not grant you the rank of master. - Mace Windu", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Mace Windu/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Mace Windu/Wind.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceDrain.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceDrain.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                         
                         
                                             
                     
                        ForceStun.SetUpPower(person.Limbs[11], person);
                        ForceStun.SetUpPower(person.Limbs[13], person);
                        ForceCombustion.SetUpPower(person.Limbs[11], person);
                        ForceCombustion.SetUpPower(person.Limbs[13], person);
                        ElectricJudgement.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered


                    }
                }
                   );
                               //Mace Windu
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>General Hux", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "All remaining systems will bow before The First Order and will remember this as the last day of The Republic. - General Hux", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/General Hux/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/General Hux/General Hux.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered


                    }
                }
                   );
            ///HIGHLIGHT FROM HERE
            ///HIGHLIGHT FROM HERE
            // Poe Dameron
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>Poe Dameron", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Permission to jump in an X-Wing and blow something up? - Poe Dameron", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Poe Dameron/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Poe Dameron/Poe Dameron.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin, null, null, 1);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Finn
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>Finn", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I'm a big deal in the Resistance. - Finn", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Finn/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Finn/Finn.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin, null, null, 1);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE


            // Veteran Smuggler Han Solo
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>Veteran Smuggler Han Solo", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "That's not how the Force works! - Veteran Smuggler Han Solo", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Han Solo/thumb2.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Han Solo/Veteran Smuggler Han Solo.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE

            // Anakin Skywalker
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Anakin Skywalker", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "This is where the fun begins! - Anakin Skywalker", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Anakin Skywalker/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Anakin Skywalker/skin layer.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);
                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                         
                         
                                             
                     

                        person.Limbs[11].IsAndroid = true;
                        person.Limbs[11].CirculationBehaviour.BleedingRate = 0.000000000f;
                        person.Limbs[11].CirculationBehaviour.BloodFlow = 0.000000000f;
                        person.Limbs[11].PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                        NewLimbTexture.SetBodyPartTexture(person.Limbs[11], ModAPI.LoadTexture("Characters/Anakin Skywalker/skin layer roboman.png"), ModAPI.LoadTexture("Characters/Anakin Skywalker/flesh layer robo.png"));
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Anakin Skywalker/Anakin Attack of the clones.png"), "Anakin Skywalker (attack of the clones)", "Anakin Skywalker (attack of the clones)");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Characters/Anakin Skywalker/Anakin Episode 2.png"), "Anakin Skywalker (episode 2)", "Anakin Skywalker (episode 2)");


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
                   );
            ///TO HERE

            ///HIGHLIGHT FROM HERE
            // The Mandalorian (Beskar Armor)
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>The Mandalorian (Beskar Armor)", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "This is the way. - The Mandalorian (Beskar Armor)", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/The Mandalorian/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/The Mandalorian/Beskar Mando.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                                                foreach (var body in person.Limbs)
                        {
                                body.PhysicalBehaviour.ReflectsLasers = true;
                        }

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/The Mandalorian/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/The Mandalorian/cape01.png"));


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
                        ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzwraith", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "i dont know why i didnt make this a clone and just modify it but oh well", //new item description
                    CategoryOverride = ModAPI.FindCategory(""), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite(""), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("wraith.png");
                    AudioSource audioSource = Instance.AddComponent<AudioSource>();
					audioSource = Instance.AddComponent<AudioSource>();
					audioSource.minDistance = 20;
					audioSource.maxDistance = 100;
					AudioClip clip = ModAPI.LoadSound("laugh.mp3");
					audioSource.clip = clip;
						audioSource.Play();

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                                                foreach (var body in person.Limbs)
                        {
                                body.gameObject.layer = 10;
                                body.gameObject.GetComponent<PhysicalBehaviour>().MakeWeightless();
                                body.gameObject.AddComponent<ForceWraith>();
                        }

                        person.Limbs[4].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                        person.Limbs[5].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                        person.Limbs[6].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                        person.Limbs[7].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                        person.Limbs[8].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                        person.Limbs[9].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

                        // The Mandalorian (Beskar Armor)
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Cara Dune", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Would not wanna be the one who's gotta tell him. - Cara Dune", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Cara Dune/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Cara Dune/Cara Dune.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin);

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE


            ///HIGHLIGHT FROM HERE
            // Grand Admiral Thrawn
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Grand Admiral Thrawn", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Everything leading up to this moment has been rehearsal. The real performance is about to begin. - Grand Admiral Thrawn", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Grand Admiral Thrawn/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Grand Admiral Thrawn/Grand Admiral Thrawn.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>C3-PO", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Don’t you call me a mindless philosopher you overweight glob of grease! - C3-PO", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/C3-PO/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/C3-PO/C3-PO.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                       new Modification()
                       {
                           OriginalItem = ModAPI.FindSpawnable("Android"),
                           NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>General Grievous",
                           DescriptionOverride = "General kenobi, you are a bold one. - General Grievous",
                           CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"),
                           ThumbnailOverride = ModAPI.LoadSprite("Characters/General Grievous/thumb.png"),
                           AfterSpawn = (Instance) =>
                           {
                             var person = Instance.GetComponent<PersonBehaviour>();

                               var skin = ModAPI.LoadTexture("Characters/General Grievous/grievous.png");
                               var flesh = ModAPI.LoadTexture("flesh layer.png");
                               var bone = ModAPI.LoadTexture("bone layer.png");
                         var head = Instance.transform.Find("Head");
                         var upper = Instance.transform.Find("Body").Find("UpperBody");

                               person.SetBodyTextures(skin);
                               boobies = Instance;

GameObject titties = Instantiate(boobies);
var person2 = titties.GetComponent<PersonBehaviour>();
person2.Limbs[0].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[1].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[2].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[3].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[4].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[5].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[6].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[7].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[8].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
person2.Limbs[9].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();

var thisisntveryfuntoworkon = person2.Limbs[10].gameObject;
var ilikedrpepper = person2.Limbs[11].gameObject;
var superdeluxe = person2.Limbs[12].gameObject;
var jokar = person2.Limbs[13].gameObject;
			    thisisntveryfuntoworkon.transform.SetParent(Instance.transform);
                ilikedrpepper.transform.SetParent(Instance.transform);
                superdeluxe.transform.SetParent(Instance.transform);
                jokar.transform.SetParent(Instance.transform);


                                   HingeJoint2D hingeJoint = upper.gameObject.AddComponent<HingeJoint2D>();
                                   hingeJoint.connectedBody = thisisntveryfuntoworkon.gameObject.GetComponent<Rigidbody2D>();
                                   hingeJoint.anchor = new Vector3(0f, 0f);
                                   JointAngleLimits2D limits = hingeJoint.limits;
                                   limits.min = 5;
                                   limits.max = -5;
                                   hingeJoint.limits = limits;
                                   hingeJoint.useLimits = false;
                                   hingeJoint.enableCollision = false;

                                                                      HingeJoint2D hingeJoint2 = upper.gameObject.AddComponent<HingeJoint2D>();
                                   hingeJoint2.connectedBody = superdeluxe.gameObject.GetComponent<Rigidbody2D>();
                                   hingeJoint2.anchor = new Vector3(0f, 0f);
                                   JointAngleLimits2D limits2 = hingeJoint2.limits;
                                   limits2.min = 5;
                                   limits2.max = -5;
                                   hingeJoint2.limits = limits;
                                   hingeJoint2.useLimits = false;
                                   hingeJoint2.enableCollision = false;
                                                                                                    var col = thisisntveryfuntoworkon.AddComponent<NoCollide>();
                        col.NoCollideSetA = thisisntveryfuntoworkon.GetComponents<Collider2D>();
                        col.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                      var col2 = ilikedrpepper.AddComponent<NoCollide>();
                        col2.NoCollideSetA = ilikedrpepper.GetComponents<Collider2D>();
                        col2.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                                                                                                                            var col3 = thisisntveryfuntoworkon.AddComponent<NoCollide>();
                        col3.NoCollideSetA = superdeluxe.GetComponents<Collider2D>();
                        col3.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                      var col4 = jokar.AddComponent<NoCollide>();
                        col4.NoCollideSetA = jokar.GetComponents<Collider2D>();
                        col4.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();


                }
              }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#999900>[Legends]<color=white>Jedi Knight Revan", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "You could warn me when I do something bad. Blink once for dark side, twice for light. - Darth Revan", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Jedi Knight Revan/jedi revan thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Jedi Knight Revan/Jedi Knight Revan.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Jedi Knight Revan/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/Jedi Knight Revan/cape01.png"));

                        ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        ForceDrain.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceDrain.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        ForceLightning.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceLightning.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceBleeding.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                        ForceBleeding.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                                                MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);

                        person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0.5f;
                        person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0.5f;
                        person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 1f;
                        person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0.5f;
                        person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0.5f;
                        person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 1f;

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            // Moff Gideon
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Chewbacca", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Graaaahh - Chewbacca", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Chewbacca/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Chewbacca/chewbacca.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Princess Leia", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Aren’t you a little short for a stormtrooper? – Princess Leia", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Princess Leia/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Princess Leia/leia.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Captain Rex", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The war left its scars on all of us. – Captain Rex", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Captain Rex/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Captain Rex/captain rex.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Captain Rex/head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Palpatine", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I Am All The Sith. - Palpatine", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Palpatine/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Palpatine/palpatine.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                                                ForceChoke.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        ForceChoke.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Choke.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                                                ForceDrain.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceDrain.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Drain.png"));
                        ForceLightning.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceLightning.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Lightning.png"));
                        ForceBleeding.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                        ForceBleeding.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Force Bleeding.png"));
                                                MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                                                ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                         
                         
                                             
                     
                        ForceStun.SetUpPower(person.Limbs[11], person);
                        ForceStun.SetUpPower(person.Limbs[13], person);
                        DarkTransfer.SetUpPower(person.Limbs[11], person);
                        DarkTransfer.SetUpPower(person.Limbs[13], person);
                        ForceCombustion.SetUpPower(person.Limbs[11], person);
                        ForceCombustion.SetUpPower(person.Limbs[13], person);
                        ElectricJudgement.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));
                        ElectricJudgement.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Electric Judgement.png"));

person.Limbs[11].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[11].gameObject.GetComponent<ForceLightning>().B = 1f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().R = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().G = 0.5f;
person.Limbs[13].gameObject.GetComponent<ForceLightning>().B = 1f;

                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ModAPI.LoadSprite("Characters/Palpatine/cape02.png"), 0.08f, ModAPI.LoadSprite("Characters/Palpatine/cape01.png"));


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Legends]<color=white>Bastila Shan", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I take it back. Let's congratulate his wife. - Bastila Shan", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Bastila Shan/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Bastila Shan/bastila shan.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Bastila Shan/head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();


                        ForceHeal.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        ForceHeal.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Force Heal.png"));
                        Ionize.SetUpPower(person.Limbs[11], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        Ionize.SetUpPower(person.Limbs[13], ModAPI.LoadSprite("Ui/Power Icons/Ionize.png"));
                        MindTrick.SetUpPower(person.Limbs[11], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MindTrick.SetUpPower(person.Limbs[13], person, ModAPI.LoadSprite("Ui/Power Icons/Mind Trick.png"));
                        MagicPush.SetUpPower(person.Limbs[11], person);
                        MagicPush.SetUpPower(person.Limbs[13], person);
                        MagicPush.SetUpPower(person.Limbs[11], person,IconForcePull,"Force Pull",-40);
                        MagicPush.SetUpPower(person.Limbs[13], person, IconForcePull, "Force Pull", -40);
                         
                         
                                             
                     


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>IG-11", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "There is nothing to be sad about. I have never been alive. - IG-11", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/IG-11/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/IG-11/ig-11.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        foreach (var body in person.Limbs)
                        {
                  body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                  body.IsAndroid = true;
                        }


                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>C1-10P", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Chopper, sometimes you do it right. - C1-10P", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/C1-10P/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/C1-10P/c1_base.png");
                        Instance.FixColliders();

					var billson = new GameObject();
					billson.transform.SetParent(Instance.transform);
					billson.transform.localPosition = new Vector3(1f, 0.6f);
					var billsonSprite = billson.AddComponent<SpriteRenderer>();
					billsonSprite.sprite = ModAPI.LoadSprite("Characters/R2D2/billson.png", 1f);
					billsonSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
					billsonSprite.color = new Color(0.0f, 0f, 0f, 0.10f);
					billsonSprite.sortingLayerName = "Top";

Instance.AddComponent<funnybillson>().billson = billson;

                             var leg = new GameObject("leg");
                              leg = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                                          leg.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                              SpriteRenderer legRenderer = leg.GetComponent<SpriteRenderer>();
                                          legRenderer.sprite = ModAPI.LoadSprite("Characters/C1-10P/c1_leg2.png", 1f);
                                          legRenderer.sortingLayerName = "Middle";
			    leg.transform.SetParent(Instance.transform);
                                          leg.transform.localScale = new Vector3(1f, 1f);
                        leg.FixColliders();


                                   HingeJoint2D hingeJoint = leg.GetOrAddComponent<HingeJoint2D>();
                                   hingeJoint.connectedBody = Instance.GetComponent<Rigidbody2D>();
                                   hingeJoint.anchor = new Vector3(0f, -0.1f);
                                   JointAngleLimits2D limits = hingeJoint.limits;
                                   limits.min = 5;
                                   limits.max = -5;
                                   hingeJoint.limits = limits;
                                   hingeJoint.useLimits = true;
                                   hingeJoint.enableCollision = false;

                                   leg.transform.localPosition = new Vector3(0f, -0.2f);

                             var leg2 = new GameObject("leg2");
                              leg2 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                                          leg2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                              SpriteRenderer leg2Renderer = leg2.GetComponent<SpriteRenderer>();
                                          leg2Renderer.sprite = ModAPI.LoadSprite("Characters/C1-10P/c1_leg2.png", 1f);
                                          leg2Renderer.sortingLayerName = "Bottom";
			    leg2.transform.SetParent(Instance.transform);
                                          leg2.transform.localScale = new Vector3(1f, 1f);
                        leg2.FixColliders();


                                   HingeJoint2D hingeJoint2 = leg2.GetOrAddComponent<HingeJoint2D>();
                                   hingeJoint2.connectedBody = Instance.GetComponent<Rigidbody2D>();
                                   hingeJoint2.anchor = new Vector3(0f, -0.1f);
                                   JointAngleLimits2D limits2 = hingeJoint2.limits;
                                   limits2.min = 5;
                                   limits2.max = -5;
                                   hingeJoint2.limits = limits;
                                   hingeJoint2.useLimits = true;
                                   hingeJoint2.enableCollision = false;

                                   leg2.transform.localPosition = new Vector3(0f, -0.2f);
                            leg2.gameObject.layer = 10;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Hera Syndulla", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "We have hope; hope that things can get better. And they will.  - Hera Syndulla", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Hera Syndulla/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Hera Syndulla/Hera Syndulla.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Hera Syndulla/Hera Head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();
                        person.Limbs[0].transform.localPosition = new Vector3(-0.0364f, 0.7528f, 0);

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Prequel]<color=white>Qui-Gon Jinn", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "There’s always a bigger fish. - Qui-Gon Jinn", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Qui Gon Jin/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Qui Gon Jin/Qui Gon Jin.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Qui Gon Jin/qui gon head.png", 10f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].transform.localPosition = new Vector3(-0.0083f,0.697f,0); 

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    //change V this V to Android for androids - cam
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFFCC>[Others]<color=white>Garazeb Orrelios", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "It's just something about the feel of their helmets on my fists. - Garazeb Orrelios", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Garazeb Orrelios/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer
                        var skin = ModAPI.LoadTexture("Characters/Garazeb Orrelios/zeb.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows:
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        //If you don't want to change the flesh and bone texture, change it to person.SetBodyTextures(skin); - cam
                        person.SetBodyTextures(skin);

                        person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("Characters/Garazeb Orrelios/zeb head.png", 1f);
                                                person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("Characters/Rey (Scavanger)/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();

                        //You don't really need to touch this, blood color doesn't even work lol - cam
                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(96, 96, 96); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(128, 128, 128); //second bruise colour. red by default
                        person.SetThirdBruiseColor(160, 160, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ///TO HERE

            #endregion



            #region Items
            // Han Solo's DL-44 Heavy Blaster
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>Han Solo's DL-44 Heavy Blaster", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The DL-44 heavy blaster pistol, also known more simply as a DL-44 blaster pistol, was a type of heavy blaster pistol produced by BlasTech Industries.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Han Solo/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Han Solo/Han Solo's DL-44 Heavy Blaster.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[3]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Han Solo/Sounds/Gun 1.wav"),
                        ModAPI.LoadSound("Characters/Han Solo/Sounds/Gun 2.wav"),
                        ModAPI.LoadSound("Characters/Han Solo/Sounds/Gun 3.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>DC-17 Blaster Pistol", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A heavy blaster pistol wielded by the clone troopers of the Grand Army of the Galactic Republic during the Clone Wars.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Captain Rex/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Captain Rex/gun.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[3]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Han Solo/Sounds/Gun 1.wav"),
                        ModAPI.LoadSound("Characters/Han Solo/Sounds/Gun 2.wav"),
                        ModAPI.LoadSound("Characters/Han Solo/Sounds/Gun 3.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );

            // this is not right!!!
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>Imperial Royal Guard Staff", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A sharp staff used by the Imperial Royal Guards", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Royal Guard/staffthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Royal Guard/brewneneneew.png");
                        var properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.Sharp = true;
                        properties.SharpAxes = new SharpAxis[]
                        {
                            new SharpAxis(Vector2.up, 0f, 1.1f, true, false),
                            new SharpAxis(Vector2.down, 0f, 1.1f, true, false),
                        };

Instance.GetComponent<PhysicalBehaviour>().Properties = properties;

                        Instance.FixColliders();
                    }
                }
            );

            //E-11 Blaster Rifle/fortnite gun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>E-11 Blaster Rifle", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The weapon of choice and standard issue for the Stormtroopers of the Galactic Empire.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Storm Trooper/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Storm Trooper/E-11 Blaster Rifle.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.23f;
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[3]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Storm Trooper/pew.wav"),
                        ModAPI.LoadSound("Characters/Storm Trooper/pew2.wav"),
                        ModAPI.LoadSound("Characters/Storm Trooper/pew3.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );

            //procnessl;eipoguin
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>Satine's Lament", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Satine's Lament, also known as Leia's blaster, was a model of the Defender sporting blaster pistol produced by Drearian Defense Conglomerate.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Princess Leia/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Princess Leia/gun.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[3]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Storm Trooper/pew.wav"),
                        ModAPI.LoadSound("Characters/Storm Trooper/pew2.wav"),
                        ModAPI.LoadSound("Characters/Storm Trooper/pew3.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );

            //E-11 Blaster Rifle/fortnite gun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>E-5 Blaster Rifle", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used by B1-series battle droids and BX-series droid commandos.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/B1/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/B1/E-5 Blaster Rifle.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.19f;
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[3]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Storm Trooper/pew.wav"),
                        ModAPI.LoadSound("Characters/Storm Trooper/pew2.wav"),
                        ModAPI.LoadSound("Characters/Storm Trooper/pew3.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );

            //E-11 Blaster Rifle/fortnite gun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>ST-W48 Blaster", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A blaster used by the Sith troopers of the Sith Eternal's Final Order, including the trooper ST-I4191.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Sith Trooper/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Sith Trooper/ST-W48 Blaster.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.23f;
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[3]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Storm Trooper/pew.wav"),
                        ModAPI.LoadSound("Characters/Storm Trooper/pew2.wav"),
                        ModAPI.LoadSound("Characters/Storm Trooper/pew3.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );


            // The Mandalorian's Blaster Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>The Mandalorian's Blaster Pistol", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The bounty hunter Din Djarin carried an IB-94 blaster pistol manufactured by BlasTech Industries with him during his bounty hunting career.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/The Mandalorian/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/The Mandalorian/The Mandalorian's Blaster Pistol.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[1]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/The Mandalorian/Sounds/Gun 1.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );


            // The Mandalorian's Amban Phase-Pulse Blaster
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>The Mandalorian's Amban Phase-Pulse Blaster", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The Amban phase-pulse blaster, also known as an Amban sniper rifle, was a type of disruptor sniper rifle used by the Mandalorian bounty hunter Din Djarin.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/The Mandalorian/gunthumb 2.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/The Mandalorian/The Mandalorian's Amban Phase-Pulse Blaster.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[1]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/The Mandalorian/Sounds/Gun 2.wav")};

                        //Instance.AddComponent<MultiShotBehavour>().BulletAmount = 5;
                        //Instance.GetComponent<BlasterBehaviour>().InaccuracyMultiplier = 0.05f; //this is the normal value.
                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );


            // Luke Skywalker's Lightsaber
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Luke Skywalker's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "This weapon's design was based on schematics Luke found in his mentor's hut on Tatooine. While the final product remained largely faithful to these designs, Luke simplified the weapon considerably, as this was his first attempt at constructing a lightsaber.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/lukeThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Luke_Skywalkers_Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(0, 153, 0, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>The Darksaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The Darksaber was an ancient black-bladed lightsaber. It had a unique blade that was shorter than that of most lightsabers, and shaped like a traditional sword.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/darksThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Darksaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(100, 100, 100, 155), new Vector2(0f, 1.21f), ModAPI.LoadSprite("Lightsabers/BladeDarksaber.png"))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/dsOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/dsClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/dsIdle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );

            // Yodas's Lightsaber
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Yodas' Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Yoda constructed this lightsaber as an apprentice under the instruction of the architect droid Huyang. It is possible Yoda did this onboard the Crucible after acquiring his crystal on Ilum. The Jedi Master used the lightsaber in numerous battles and skirmishes in the Clone Wars.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/yodaThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Yodas Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(0, 153, 0, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.40f, 0.40f); //Making it smaller in general
                    }
                }
            );


            // Darth Revan's Lightsaber
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Darth Revan's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Revan's lightsaber was the personal weapon of the renowned ex-Jedi General Revan.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/DRevanThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Jedi Revan Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(51, 0, 102, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );



            // Darth Vader's Lightsaber
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Darth Vader's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "After pledging himself to the Sith Lord Darth Sidious, Anakin Skywalker took the name Darth Vader but continued to use the blue-bladed lightsaber he’d fought with during the Clone Wars. He lost this weapon on Mustafar and constructed a replacement with the crimson blade favored by the Sith.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/DVaderThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Darth Vaders Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(179, 0, 0, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );

            // Darth Nuihuhuhudufhuifdguiysfgiuydfgydfghyiurdghyfiudfg's Lightsaber
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Darth Nihilus' Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The personal lightsaber of the Sith Lord Darth Nihilus during the First Jedi Purge.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/DeezNutsThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Darth NiceNice Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(179, 0, 0, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );


            // Darth Malak's Lightsaber
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Darth Malak's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Darth Malak constructed his Sith lightsaber some time after meeting the Sith Emperor. During the Jedi Civil War, he would use it against the Jedi he once fought alongside.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/DMalekThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Darth Maleks Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(179, 0, 0, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );

            // Saber Staff
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Saber Staff", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A specialized type of lightsaber that consisted of a single hilt with a beam emitter at both ends, resulting in a weapon that was wielded in a similar manner to a traditional quarterstaff. Indeed, the design was likely influenced by the Zabrak quarterstaff, or zhaboka.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/DMaulThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Maul Saberstaff.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(179, 0, 0, 255), new Vector2(0f, 1.21f)),
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * -13.5f), 180f, new Color32(179, 0, 0, 255), new Vector2(0f, -1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );

                        // Saber Staff
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Bastila Shan's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A double-bladed lightsaber during the Jedi Civil War.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/bsLightsaber.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Bastila Shan's Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(179, 179, 0, 255), new Vector2(0f, 1.21f)),
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * -13.5f), 180f, new Color32(179, 179, 0, 255), new Vector2(0f, -1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Grand Inquisitor's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The Grand Inquisitor's lightsaber was the personal double-bladed spinning lightsaber of the Jedi hunter known as the Grand Inquisitor, similar to those wielded by the other Imperial Inquisitors.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/GIThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/grand inquisitor lightsaber.png", 1.5f);
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(179, 0, 0, 255), new Vector2(0f, 1.21f)),
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * -13.5f), 180f, new Color32(179, 0, 0, 255), new Vector2(0f, -1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );

            // rrrrrrr
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>R2-D2", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Waaaaaaaaaaaaaa - R2-D2", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/R2D2/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/R2D2/r2_base.png");
                        Instance.FixColliders();

                                   Instance.AddComponent<AudioSource>().spatialBlend = 1;
           Instance.GetComponent<AudioSource>().clip = ModAPI.LoadSound("Characters/R2D2/who.wav");
           AudioSource audio = Instance.AddComponent<AudioSource>();

					var billson = new GameObject();
					billson.transform.SetParent(Instance.transform);
					billson.transform.localPosition = new Vector3(1f, 0.6f);
					var billsonSprite = billson.AddComponent<SpriteRenderer>();
					billsonSprite.sprite = ModAPI.LoadSprite("Characters/R2D2/billson.png", 1f);
					billsonSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
					billsonSprite.color = new Color(0.0f, 0f, 0f, 0.10f);
					billsonSprite.sortingLayerName = "Top";


Instance.AddComponent<funnybillson>().billson = billson;

                             var leg = new GameObject("leg");
                              leg = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                                          leg.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                              SpriteRenderer legRenderer = leg.GetComponent<SpriteRenderer>();
                                          legRenderer.sprite = ModAPI.LoadSprite("Characters/R2D2/r2_leg2.png", 1f);
                                          legRenderer.sortingLayerName = "Middle";
			    leg.transform.SetParent(Instance.transform);
                                          leg.transform.localScale = new Vector3(1f, 1f);


                                   HingeJoint2D hingeJoint = leg.GetOrAddComponent<HingeJoint2D>();
                                   hingeJoint.connectedBody = Instance.GetComponent<Rigidbody2D>();
                                   hingeJoint.anchor = new Vector3(0f, -0.1f);
                                   JointAngleLimits2D limits = hingeJoint.limits;
                                   limits.min = 5;
                                   limits.max = -5;
                                   hingeJoint.limits = limits;
                                   hingeJoint.useLimits = true;
                                   hingeJoint.enableCollision = false;

                                   leg.transform.localPosition = new Vector3(0f, -0.1f);

                             var leg2 = new GameObject("leg2");
                              leg2 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                                          leg2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                              SpriteRenderer leg2Renderer = leg2.GetComponent<SpriteRenderer>();
                                          leg2Renderer.sprite = ModAPI.LoadSprite("Characters/R2D2/r2_leg2.png", 1f);
                                          leg2Renderer.sortingLayerName = "Bottom";
			    leg2.transform.SetParent(Instance.transform);
                                          leg2.transform.localScale = new Vector3(1f, 1f);
                        leg2.FixColliders();


                                   HingeJoint2D hingeJoint2 = leg2.GetOrAddComponent<HingeJoint2D>();
                                   hingeJoint2.connectedBody = Instance.GetComponent<Rigidbody2D>();
                                   hingeJoint2.anchor = new Vector3(0f, -0.1f);
                                   JointAngleLimits2D limits2 = hingeJoint2.limits;
                                   limits2.min = 5;
                                   limits2.max = -5;
                                   hingeJoint2.limits = limits;
                                   hingeJoint2.useLimits = true;
                                   hingeJoint2.enableCollision = false;

                                   leg2.transform.localPosition = new Vector3(0f, -0.1f);
                            leg2.gameObject.layer = 10;
                    }
                }
            );
                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#CCCC00>[Original]<color=white>Gonk Droid", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Gonk! - Gonk Droid", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Gonk Droid/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Gonk Droid/GONK.png");
                        Instance.FixColliders();
                    }
                }
            );

            // mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#FFFF66>[Sequel]<color=white>BB-8", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Droid noises - BB-8", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/BB-8/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/BB-8/head.png");
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = true;
                        Instance.FixColliders();

                              var head = new GameObject("head");
                              head = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Wheel").Prefab);
                              head.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                                          SpriteRenderer headRenderer = head.GetComponent<SpriteRenderer>();
                                          headRenderer.sprite = ModAPI.LoadSprite("Characters/BB-8/BallsHaha.png", 1f);
                                          headRenderer.sortingLayerName = "Bottom";
			                  head.transform.SetParent(Instance.transform);
                                          head.transform.localScale = new Vector3(1f, 1f);
                                          head.GetComponent<PhysicalBehaviour>().MakeWeightless();
                    foreach (UnityEngine.Object component in head.GetComponents<Collider2D>())
                    UnityEngine.Object.Destroy(component);
                    head.AddComponent<CircleCollider2D>();
                    head.GetComponent<CircleCollider2D>().radius = 0.60f;

                                   HingeJoint2D hingeJoint = head.GetOrAddComponent<HingeJoint2D>();
                                   hingeJoint.connectedBody = Instance.GetComponent<Rigidbody2D>();
                                   hingeJoint.anchor = new Vector3(0f, 0f);
                                   JointAngleLimits2D limits = hingeJoint.limits;
                                   limits.min = 5;
                                   limits.max = -5;
                                   hingeJoint.limits = limits;
                                   hingeJoint.useLimits = false;
                                   hingeJoint.enableCollision = false;

                                   head.transform.localPosition = new Vector3(0f, -0.4f);

                    }
                }
            );

            // Boba Fett's EE-3 Carbine Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>Boba Fett's EE-3 Carbine Rifle", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The EE-3 carbine rifle was a model of blaster carbine manufactured by BlasTech Industries.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Boba Fett, Scion of Jango/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Boba Fett, Scion of Jango/Boba Fett's EE-3 Carbine Rifle.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[2]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Boba Fett, Scion of Jango/Sounds/Gun 1.wav"),
                          ModAPI.LoadSound("Characters/Boba Fett, Scion of Jango/Sounds/Gun 2.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );


            // Sith Empire Trooper's DLA-13 Blaster Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>Sith Empire Trooper's DLA-13 Blaster Rifle", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The DLA-13 heavy blaster rifle was a type of blaster rifle available during the Cold War between the Galactic Republic and the Sith Empire.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Sith Empire Trooper/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Sith Empire Trooper/Sith Empire Trooper's DLA-13 Blaster Rifle.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[1]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Sith Empire Trooper/Sounds/Gun 1.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );


            // Count Dooku's Lightsaber
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Count Dooku's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Dooku's lightsaber, also known as Darth Tyranus' lightsaber or Dooku's Sith lightsaber, was the personal curved-hilt lightsaber of Dooku, the Count of Serenno.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/CDookuThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Count Dookus Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(179, 0, 0, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );

            // Moff Gideon's Blaster Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>Moff Gideon's Blaster Pistol", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The blaster pistol was a common weapon used by both military personnel and civilians. It came in a variety of shapes, sizes, and capabilities.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Moff Gideon/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Moff Gideon/Moff Gideon's Blaster Pistol.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[1]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Moff Gideon/Sounds/Gun 1.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );


            // Dark Trooper's Blaster Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>Dark Trooper's Blaster Rifle", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Blaster rifles were weapons more powerful and larger than other types of blasters, such as blaster pistols. It was used in various factions.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Dark Trooper/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Dark Trooper/Dark Trooper's Blaster Rifle.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[1]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Dark Trooper/Sounds/Gun 1.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );
//gah
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Kylo Ren's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "An ancient design that recalls weapons seen millennia ago during the Great Scourge of Malachor.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/KyloThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Kylo Rens Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(179, 0, 0, 255), new Vector2(0f, 1.21f)),
                            new LightBlade(new Vector2(-ModAPI.PixelSize * 0.125f, ModAPI.PixelSize * 7.5f), 90f, new Color32(179, 0, 0, 255), new Vector2(-0.315f, 0f), ModAPI.LoadSprite("Lightsabers/BladeSmall.png")),
                            new LightBlade(new Vector2(ModAPI.PixelSize * 0.125f, ModAPI.PixelSize * 7.5f), -90f, new Color32(179, 0, 0, 255), new Vector2(0.315f, 0f), ModAPI.LoadSprite("Lightsabers/BladeSmall.png"))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.AddComponent<balls>();
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );

            // Obi-Wan Kenobi's Lightsaber
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Obi-Wan Kenobi's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Obi-Wan Kenobi's third lightsaber was the third, and final, lightsaber to be constructed and wielded by Jedi Master Obi-Wan Kenobi during the Clone Wars after he lost his second one prior to the First Battle of Geonosis.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/ObiWanThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Obi Wans Lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(0, 183, 189, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Kanan Jarrus' Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The personal two-piece lightsaber of Kanan Jarrus, a Padawan who survived the destruction of the Jedi Order and eventually served in the Rebellion against the Galactic Empire.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/KThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/jarrus saber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(0, 183, 189, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );

            // a's Lightsaber
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Ahsoka Tano's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A single-bladed weapon with a cylindrical silver hilt with black ornamentation.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/AhsokaThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Ahsokas lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(0, 153, 0, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = ModTag + "<color=#404040>[Lightsaber]<color=white>Qui Gon Jin's Lightsaber", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Wielded by the human Jedi Master Qui-Gon Jinn. Jinn used this lightsaber until the Battle of Naboo, where he was mortally wounded by the Sith Lord Darth Maul. Qui-Gon's apprentice, Obi-Wan Kenobi, then used the same lightsaber to defeat Maul after losing his own. After the battle, Kenobi used it as his own before constructing a new lightsaber.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Lightsabers/Thumbnail/QuiThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightsabers/Qui Gon Jin lightsaber.png");
                        Instance.AddComponent<LightStabberBehaviour>().BeforeBlades = new LightBlade[]
                        {
                            new LightBlade(new Vector2(0f, ModAPI.PixelSize * 13.5f), 0f, new Color32(0, 153, 0, 255), new Vector2(0f, 1.21f))
                        };
                        Instance.GetComponent<LightStabberBehaviour>().Open = ModAPI.LoadSound("Lightsabers/Sounds/LukeOpen.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Close = ModAPI.LoadSound("Lightsabers/Sounds/LukeClose.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Idle = ModAPI.LoadSound("Lightsabers/Sounds/Idle.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Lock = ModAPI.LoadSound("Lightsabers/Sounds/Lock.wav");
                        Instance.GetComponent<LightStabberBehaviour>().LockIn = ModAPI.LoadSound("Lightsabers/Sounds/LockIn.wav");
                        Instance.GetComponent<LightStabberBehaviour>().Swing = new AudioClip[]
                        {
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing1.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing2.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing3.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing4.wav"),
                            ModAPI.LoadSound("Lightsabers/Sounds/Swing5.wav"),
                        };
                        Instance.FixColliders();
                        Instance.transform.localScale = new Vector2(0.47f, 0.47f); //Making it smaller in general
                    }
                }
            );


            // EL-16 Blaster Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>EL-16 Blaster Rifle", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The EL-16 blaster rifle was a blaster rifle manufactured by BlasTech Industries. A Heavy Field Edition of the EL-16, the EL-16HFE blaster rifle, was also used by the Resistance.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Finn/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Finn/EL-16 blaster rifle.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[1]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Dark Trooper/Sounds/Gun 1.wav")};


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>Bowcaster", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used by Chewbacca.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Chewbacca/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Chewbacca/gun.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.3f;
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[5]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        {
                        ModAPI.LoadSound("Characters/Chewbacca/gun sound1.mp3"),
                        ModAPI.LoadSound("Characters/Chewbacca/gun sound2.mp3"),
                        ModAPI.LoadSound("Characters/Chewbacca/gun sound3.mp3"),
                        ModAPI.LoadSound("Characters/Chewbacca/gun sound4.mp3"),
                        ModAPI.LoadSound("Characters/Chewbacca/gun sound5.mp3"),
                        };


                        foreach (Transform item in Instance.transform)
                        {
                            if (item.name.Contains("light"))
                            {
                                GameObject.Destroy(item.gameObject);
                            }
                            else if (item.name.Contains("glow"))
                            {
                                //google color selector on google and use the rgb output
                                item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                            }
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"), //item to derive from
                    NameOverride = ModTag + "<color=#606060>[Weapon]<color=white>RK-3 Blaster", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used by Grand Admiral Thrawn.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Star Wars Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Characters/Grand Admiral Thrawn/gunthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/Grand Admiral Thrawn/gun.png");
                        Instance.FixColliders();
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.26f;
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[3]
                        //You can change the blaster sounds here and add more if you need to. - cam
                        { ModAPI.LoadSound("Characters/Storm Trooper/pew.wav"),
                          ModAPI.LoadSound("Characters/Storm Trooper/pew2.wav"),
                          ModAPI.LoadSound("Characters/Storm Trooper/pew3.wav")};

                          foreach (Transform item in Instance.transform)
                          {
                              if (item.name.Contains("light"))
                              {
                                  GameObject.Destroy(item.gameObject);
                              }
                              else if (item.name.Contains("glow"))
                              {
                                  //google color selector on google and use the rgb output
                                  item.gameObject.GetComponent<SpriteRenderer>().color = new Color32(215, 94, 255, 0);
                              }
                          }
                    }
                }
            );

            #endregion
        }
    }

    public class LightBlade
    {
        public LightBlade(Vector2 pos, float rot, Color col, Vector2 upper, Sprite over = null)
        {
            this.Pos = pos;
            this.Rot = Quaternion.Euler(0f, 0f, rot);
            this.Color = col;
            this.Upper = upper; //laziness? yeah
            if (over != null)
            {
                this.Blade = over;
            }
        }

        public Vector2 Pos;
        public Quaternion Rot;
        public Sprite Blade = SWPP.Bladey;
        public Color Color;
        public Vector2 Upper;
    }

    public class LightStabberBehaviour : MonoBehaviour, Messages.IUse
    {
        public bool Dark;
        public bool Used;
        public AudioClip Open;
        public AudioClip Close;
        public AudioClip Idle;
        public AudioClip Lock;
        public AudioClip LockIn;
        public AudioClip[] Swing;
        public LightBlade[] BeforeBlades;
        private Dictionary<GameObject, LightBlade> Blades = new Dictionary<GameObject, LightBlade>();
        private bool CantUse;
        private AudioSource Aud;

        private void Start()
        {
            this.Aud = this.gameObject.AddComponent<AudioSource>();
            this.Aud.clip = this.Idle;
            this.Aud.loop = true;
            this.Aud.Stop(); //jic
            this.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            foreach (var blade in BeforeBlades)
            {
                GameObject Blade = new GameObject("Blade", new Type[]
                {
                    typeof(SpriteRenderer),
                    typeof(BounceBehaviour) //lazy
                });
                Blade.GetComponent<SpriteRenderer>().sprite = blade.Blade;
                Blade.transform.SetParent(this.transform);
                Blade.transform.position = this.transform.TransformPoint(blade.Pos);
                Blade.transform.rotation = this.transform.rotation * blade.Rot;
                Blade.GetComponent<SpriteRenderer>().color = blade.Color;
                Blade.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                Blade.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                Blade.FixColliders();
                Blade.GetComponent<Collider2D>().isTrigger = true;
                Blade.SetLayer(9);
                Blade.GetComponent<BounceBehaviour>().Lock = this.Lock;
                Blade.GetComponent<BounceBehaviour>().LockIn = this.LockIn;
                Blade.GetComponent<BounceBehaviour>().pos = Blade.transform.InverseTransformPoint(this.transform.TransformPoint(blade.Pos));
                Blade.transform.localScale = new Vector2(1f, 0f);
                Blade.AddComponent<SwingingNoiseBehaviour>().clips = this.Swing;
                Blade.GetComponent<SwingingNoiseBehaviour>().body = this.gameObject.GetComponent<Rigidbody2D>();
                var col = new GameObject("BladeCol");
                col.AddComponent<SpriteRenderer>().sprite = blade.Blade;
                col.FixColliders();
                col.GetComponent<SpriteRenderer>().color = Color.clear;
                col.transform.SetParent(Blade.transform);
                col.transform.localPosition = Vector2.zero;
                col.transform.rotation = Blade.transform.rotation;
                col.transform.localScale = Vector2.one;
                col.SetLayer(17);
                col.gameObject.AddComponent<BounceBehaviour>();
                this.Blades.Add(Blade, blade);
            }
        }

        public void Use(ActivationPropagation act)
        {
            if (this.CantUse)
            {
                return;
            }
            this.Used = !this.Used;
            if (Used)
            {
                this.Aud.Play();
                this.gameObject.GetComponent<Rigidbody2D>().AddRelativeForce(Vector2.down * 0.3f, ForceMode2D.Impulse);
                this.Aud.PlayOneShot(this.Open);
                foreach (var blade in this.Blades)
                {
                    blade.Key.GetComponent<BounceBehaviour>().StartCoroutine(SmoothIntro(blade.Key, blade.Value.Pos, blade.Value.Upper));
                }
                return;
            }
            this.Aud.Stop();
            this.Aud.PlayOneShot(this.Close);
            foreach (var blade in this.Blades)
            {
                blade.Key.GetComponent<BounceBehaviour>().StartCoroutine(SmoothOutro(blade.Key, blade.Value.Pos, blade.Value.Upper));
                blade.Key.GetComponent<BounceBehaviour>().ObjsInTrigger.Clear();
            }
        }

        private IEnumerator SmoothIntro(GameObject blade, Vector2 pos, Vector2 upper)
        {
            this.CantUse = true;
            float time = 0f;
            while (blade.transform.localScale.y < 0.99f)
            {
                time += Time.deltaTime * 5f;
                blade.transform.localScale += new Vector3(0f, Time.deltaTime * 5f, 0f);
                blade.transform.localPosition = Vector2.Lerp(pos, new Vector2(pos.x, pos.y) + upper, time);
                yield return new WaitForEndOfFrame();
            }
            blade.transform.localScale = Vector2.one;
            blade.transform.localPosition = new Vector2(pos.x, pos.y) + upper;
            this.CantUse = false;
            yield return new WaitForEndOfFrame();
        }

        private IEnumerator SmoothOutro(GameObject blade, Vector2 pos, Vector2 upper)
        {
            this.CantUse = true;
            float time = 0f;
            Vector2 poss = new Vector2(pos.x, pos.y) + upper;
            while (blade.transform.localScale.y > 0.01f)
            {
                time += Time.deltaTime * 5f;
                blade.transform.localScale -= new Vector3(0f, Time.deltaTime * 5f, 0f);
                blade.transform.localPosition = Vector2.Lerp(poss, pos, time);
                yield return new WaitForEndOfFrame();
            }
            blade.transform.localPosition = pos;
            blade.transform.localScale = Vector2.right;
            this.CantUse = false;
            yield return new WaitForEndOfFrame();
        }

        public void OnDestroy()
        {
            this.Blades.Clear();
        }
    }

    public class SwingingNoiseBehaviour : MonoBehaviour
    {
        private int SwingDir = 0;
        public float MinVel = 250f;
        private AudioSource aud;
        public Rigidbody2D body;
        public AudioClip[] clips;

        private void Start()
        {
            this.aud = this.gameObject.AddComponent<AudioSource>();
            this.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
        }

        public void Update()
        {
            if (!this.transform.root.gameObject.GetComponent<LightStabberBehaviour>().Used)
            {
                return;
            }
            if (Mathf.Abs(this.body.angularVelocity) >= this.MinVel)
            {
                if (this.body.angularVelocity.ToPosNeg() != this.SwingDir)
                {
                    this.SwingDir = this.body.angularVelocity.ToPosNeg();
                    this.aud.PlayOneShot(this.clips.PickRandom<AudioClip>());
                }
            }
        }
    }

    public class BounceBehaviour : MonoBehaviour
    {
        public AudioClip Lock;
        public AudioClip LockIn;
        public AudioClip Collide;
        private AudioSource aud;
        public List<GameObject> ObjsInTrigger = new List<GameObject>();
        public Vector2 pos;

        private void Start()
        {
            this.aud = this.gameObject.AddComponent<AudioSource>();
            this.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            if (this.Lock != null)
            {
                this.aud.clip = this.Lock;
                this.aud.loop = true;
                this.aud.Stop(); //jic
            }
        }

        public void OnCollisionEnter2D(Collision2D col)
        {
            col.transform.root.GetComponent<Rigidbody2D>().velocity = Vector2.Reflect(col.transform.root.GetComponent<Rigidbody2D>().velocity, col.contacts[(int)(col.contacts.Length / 2)].normal);
        }

        public void OnTriggerEnter2D(Collider2D col)
        {
            this.StopCoroutine("FadeOut");
            this.ObjsInTrigger.Add(col.gameObject);
            this.aud.volume = 1f;
            if (this.ObjsInTrigger.Count <= 1)
            {
                this.aud.Play();
            }
            this.aud.PlayOneShot(this.LockIn);
        }

        public void OnTriggerStay2D(Collider2D col)
        {
            RaycastHit2D cast = Physics2D.Raycast(this.transform.TransformPoint(this.pos), this.transform.up, 15f, LayerMask.GetMask(new string[]
            {
                "Objects",
                "Bounds",
                "CollidingDebris"
            }));
            PhysicalBehaviour phys;
            if (col.gameObject.TryGetComponent<PhysicalBehaviour>(out phys))
            {
                if (UnityEngine.Random.value > 0.95f)
                {
                    phys.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                }
                if (cast.transform != null)
                {
                    if (UnityEngine.Random.value > 0.95f)
                    {
                        ModAPI.CreateParticleEffect("Spark", cast.point);
                    }
                    if (UnityEngine.Random.value > 0.65f)
                    {
                        ModAPI.CreateParticleEffect("Flash", cast.point);
                    }
                }
            }
        }

        public void OnTriggerExit2D(Collider2D col)
        {
            this.ObjsInTrigger.Remove(col.gameObject);
            if (this.ObjsInTrigger.Count <= 0)
            {
                this.StartCoroutine("FadeOut");
            }
        }

        private void FixedUpdate()
        {
            if (this.ObjsInTrigger.Count >= 1)
            {
                this.ObjsInTrigger = this.ObjsInTrigger.Where(item => item != null).ToList();
            }
            else if (this.aud.volume > 0.99f)
            {

                this.StartCoroutine("FadeOut");
            }
        }

        public IEnumerator FadeOut()
        {
            while (this.aud.volume > 0.01f)
            {
                this.aud.volume = Mathf.Lerp(this.aud.volume, 0f, Time.deltaTime * 10f);
                yield return new WaitForEndOfFrame();
            }
            this.aud.volume = 0f;
            this.aud.Stop();
        }
    }

        public class ResourceStorage : MonoBehaviour
    {
        public List<AudioClip> WebSounds = new List<AudioClip>();
        public List<Sprite> sprites = new List<Sprite>();
        public List<Texture2D> textures = new List<Texture2D>();
        public List<string> strings = new List<string>();
    }

    public class MultiShotBehavour : MonoBehaviour, Messages.IUse
    {
        public int BulletAmount = 0;
        private BlasterBehaviour blast;
        private bool Exists;

        private void Start()
        {
            var thing = this.gameObject.TryGetComponent<BlasterBehaviour>(out blast);
            this.Exists = thing;
        }

        public void Use(ActivationPropagation prop)
        {
            if (this.Exists)
            {
                for (var i = 0; i < this.BulletAmount; i++)
                {
                    this.blast.Shoot();
                }
            }
        }
    }

    public class CustomBodyPart : MonoBehaviour
    {
        //This is for people with sprites that go out of the games sprite boundarys.

        public Sprite OgSkin;
        public Texture2D OgFlesh;
        public Texture2D OgBone;

        public Sprite NewSkin;
        public Texture2D NewFlesh;
        public Texture2D NewBone;

        //This sets the sprite back to the orignal skin that isn't custom, we use this for stuff
        //like the iron man suit and venom, so we can change to those skins.
        public void SetOriginalTextures()
        {
            this.GetComponent<SpriteRenderer>().sprite = OgSkin;
            this.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", OgFlesh);
            this.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", OgBone);
        }

        //This sets the body part to the new sprite
        public void SetNewTextures()
        {
            this.GetComponent<SpriteRenderer>().sprite = NewSkin;
            this.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", NewFlesh);
            this.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", NewBone);
        }
    }

    public class JetPack : MonoBehaviour
    {
        AudioClip Thruster = ModAPI.LoadSound("Characters/Boba Fett, Scion of Jango/Thruster.wav");

        GameObject ThrustSpriteObject;
        Sprite ThrustSprite = ModAPI.LoadSprite("Characters/Boba Fett, Scion of Jango/jet.png");

        GameObject JetPackSpriteObject = new GameObject();
        Sprite JetPackSprite = ModAPI.LoadSprite("Characters/Boba Fett, Scion of Jango/JetPack.png");
        bool flying = false;
        public LimbBehaviour body;

        public void Start()
        {
            body = GetComponent<LimbBehaviour>();


            ThrustSpriteObject = new GameObject();
            JetPackSpriteObject.AddComponent<SpriteRenderer>().sprite = JetPackSprite;
            JetPackSpriteObject.transform.SetParent(body.transform, false);
            JetPackSpriteObject.transform.localPosition = new Vector3(-0.05f, -0.25f, 0);
            JetPackSpriteObject.GetComponent<SpriteRenderer>().sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;

            body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
            {
                if (!flying)
                {
                    foreach (var item2 in body.Person.Limbs)
                    {
                        item2.PhysicalBehaviour.MakeWeightless();
                        item2.PhysicalBehaviour.InitialMass = +0.3f;
                    }
                    body.gameObject.AddComponent<ConstantForce2D>().relativeForce = new Vector2(0, 2);
                    ThrustSpriteObject = new GameObject();
                    ThrustSpriteObject.AddComponent<SpriteRenderer>().sprite = ThrustSprite;
                    ThrustSpriteObject.transform.SetParent(body.transform, false);
                    ThrustSpriteObject.transform.localScale = Vector3.one / 24;
                    ThrustSpriteObject.transform.localPosition = new Vector3(-0.15f, -0.58f, 0);
                    ThrustSpriteObject.transform.localEulerAngles = new Vector3(0, 0, 0);
                    ThrustSpriteObject.AddComponent<AudioSource>().spatialBlend = 1;
                    ThrustSpriteObject.GetComponent<AudioSource>().outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
                    ThrustSpriteObject.GetComponent<AudioSource>().loop = true;
                    ThrustSpriteObject.GetComponent<AudioSource>().clip = Thruster;
                    ThrustSpriteObject.GetComponent<AudioSource>().Play();
                    flying = true;

                }
                else
                {
                    flying = false;
                    Component.Destroy(body.gameObject.GetComponent<ConstantForce2D>());
                    GameObject.Destroy(ThrustSpriteObject);
                    Component.Destroy(ThrustSpriteObject.GetComponent<AudioSource>());
                    foreach (var item2 in body.Person.Limbs)
                    {
                        item2.PhysicalBehaviour.InitialMass = -0.3f;
                        item2.PhysicalBehaviour.MakeWeightful();
                    }
                }
            };

        }
    }

    public class NewLimbTexture
    {
        public static void SetBodyPartTexture(LimbBehaviour body, Texture2D Skin, Texture2D Flesh = null)
        {
            float scale = 1f;
            SpriteRenderer renderer = body.SkinMaterialHandler.renderer;
            Sprite sprite1 = renderer.sprite;
            Sprite sprite2 = generateFor(Skin, sprite1);
            renderer.sprite = sprite2;
            if (Flesh)
                renderer.material.SetTexture("_FleshTex", Flesh);



            Sprite generateFor(Texture2D t, Sprite original)
            {
                Texture2D texture = t;
                Rect rect1 = original.rect;
                Vector2 position = rect1.position * scale;
                rect1 = original.rect;
                Vector2 size = rect1.size * scale;
                Rect rect2 = new Rect(position, size);
                Vector2 pivot = new Vector2(0.5f, 0.5f);
                double num = (double)original.pixelsPerUnit * (double)scale;
                Vector4 border = original.border * scale;
                return Sprite.Create(texture, rect2, pivot, (float)num, 0U, SpriteMeshType.FullRect, border, false);

            }
        }
    }

    public class balls : MonoBehaviour
    {

        private void Start()
        {

        }

        public void Update()
        {
            if (UnityEngine.Random.value >= 0.99f)
            {
                SimpleLightingEmitterBehaviour.Instance.Emit(this.transform.position, UnityEngine.Random.insideUnitCircle, 0.4f, 0.3f, lent, new Color32(255, 0, 0, 255), LayerMask.GetMask(new string[] { "Bounds" }), 0f, 32);
            }
        }

        private void lent(PhysicalBehaviour phys, Vector2 pos)
        {
        }
    }

    public class funnybillson : MonoBehaviour
    {
         bool enabled = false;
	 public GameObject billson;
            private void Start()
        {
			SetEnabled(enabled);
			billson.transform.eulerAngles = transform.eulerAngles;
			billson.transform.localScale = transform.localScale;
        }

        private void Use()
        {
            enabled = !enabled;
			SetEnabled(enabled);
                if (enabled)
    {
    this.gameObject.GetComponent<AudioSource>().Play();
    }
    else{
        this.gameObject.GetComponent<AudioSource>().Stop();
    }
        }

		private void SetEnabled(bool status)
		{
			enabled = status;
			billson.GetComponent<SpriteRenderer>().color = status ? Color.white : Color.black;
		}

    }

    public static class Extens
    {
        public static int ToPosNeg(this float num)
        {
            if (num >= 0f)
            {
                return 1;
            }
            return -1;
        }
    }
       public class ForceWraith : MonoBehaviour, Messages.IStabbed, Messages.IShot
    {
        private GameObject Particles = new GameObject();
        public static Sprite none;
        public bool noParticles;

        public void Stabbed(Stabbing stab)
        {
            Gas();
        }

        public void Shot(Shot shot)
        {
            Gas();
        }

        private void Update()
        {
            if (!this.gameObject.GetComponent<LimbBehaviour>().Person.IsAlive())
            {
                Gas();
            }
        }

        private void Gas()
        {
            this.Particles.AddComponent<SpriteRenderer>().sprite = none;
            foreach (var limb in this.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (!this.noParticles)
                {
                    var smok = GameObject.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SmokeParticle"), this.transform.position, Quaternion.identity);
                    smok.AddComponent<Optout>();
                    var part = smok.GetComponent<ParticleSystem>();
                    var main = part.main;
                    main.playOnAwake = false;
                    main.loop = false;
                    main.simulationSpace = ParticleSystemSimulationSpace.World;
                    part.Stop();
                    var shape = part.shape;
                    shape.spriteRenderer = Particles.GetComponent<SpriteRenderer>();
                    var render = smok.GetComponent<ParticleSystemRenderer>();
                    render.material.color = new Color32(0, 0, 0, 255);
                    ParticleSystem.EmitParams par = new ParticleSystem.EmitParams()
                    {
                        position = limb.transform.position
                    };
                    part.Emit(par, 1);
                    smok.GetComponent<Optout>().StartCoroutine(DestroyAfterTime(smok));
                }
                limb.PhysicalBehaviour.Disintegrate();
            }
        }

        private IEnumerator DestroyAfterTime(GameObject obj)
        {
            yield return new WaitForSeconds(5f);
            GameObject.Destroy(obj);
        }
    }
        public class OtherStuff : MonoBehaviour
    {
        public static void SetBodyPartTexture(LimbBehaviour body, Texture2D Skin, Texture2D Flesh = null)
        {
            float scale = 1f;
            SpriteRenderer renderer = body.SkinMaterialHandler.renderer;
            Sprite sprite1 = renderer.sprite;
            Sprite sprite2 = generateFor(Skin, sprite1);
            renderer.sprite = sprite2;
            if (Flesh)
                renderer.material.SetTexture("_FleshTex", Flesh);



            Sprite generateFor(Texture2D t, Sprite original)
            {
                Texture2D texture = t;
                Rect rect1 = original.rect;
                Vector2 position = rect1.position * scale;
                rect1 = original.rect;
                Vector2 size = rect1.size * scale;
                Rect rect2 = new Rect(position, size);
                Vector2 pivot = new Vector2(0.5f, 0.5f);
                double num = (double)original.pixelsPerUnit * (double)scale;
                Vector4 border = original.border * scale;
                return Sprite.Create(texture, rect2, pivot, (float)num, 0U, SpriteMeshType.FullRect, border, false);

            }
        }
    }
}

//zuccian > your favourite verse😂😂😂
